from subprocess import Popen, PIPE
from os import system, remove 

methods = ["PQ", "ME", "ML", "MP", "QP"]
treedir = "./"
reference = "Reference.tre"
alidir = "../Alignments/"


methodsdir = dict()
for method in methods:
  methodsdir[method] = treedir + method + "/"

wins = dict()
for m1 in methods:
  for m2 in methods:
    if m1 != m2:
      wins[(m1, m2)] = 0

branches = open("branches.txt", "w")
branches.write("ID\t")
branches.write("\t".join(methods) + "\n")
quality = dict()

names = open("list.txt", "r")

for line in names:
  x = line.strip()
  print x
  branches.write(x) 
  system("infoseq " + alidir + x + ".fasta -only -name -nohead -auto > tmpspeclist.txt")
  system("subtree " + reference + " tmpspeclist.txt tmpref.tre > /dev/null 2>&1") 
  for method in methods:
    command = ["branchdist", "tmpref.tre", methodsdir[method] + x + ".tre"]
    branchdist = Popen(command, stdout = PIPE, stderr = PIPE)
    (out, err) = branchdist.communicate()
    # print err
    quality[method] = float(out.split()[1])
    branches.write("\t" + format(quality[method], ".4f"))
  branches.write("\n")
  remove("tmpref.tre")
  remove("tmpspeclist.txt")
  for i in range(len(methods) - 1):
    for j in range(i + 1, len(methods)):
      if quality[methods[i]] < quality[methods[j]]:
        # print n, methods[i], "wins", methods[j]
        wins[(methods[i], methods[j])] += 1
      if quality[methods[j]] < quality[methods[i]]:
        # print n, methods[j], "wins", methods[i]
        wins[(methods[j], methods[i])] += 1
branches.close()

table = open("table.txt", "w")
table.write("m1\tm2\tWins\tLosses\n")
for pair in wins.keys():
  m1 = pair[0]
  m2 = pair[1]
  table.write(m1 + "\t" + m2 + "\t" + str(wins[(m1, m2)]) + "\t" + str(wins[(m2, m1)]) + "\n")
table.close()
# end
