from subprocess import Popen, PIPE
from time import strftime, gmtime
from sys import stderr, exit
from os import access, F_OK, rename, remove

if access("infile_fastme_tree.txt", F_OK):
  remove("infile_fastme_tree.txt")
if access("infile_fastme_stat.txt", F_OK):
  remove("infile_fastme_stat.txt")

names = open("list.txt", "r")

for line in names:
  x = line.strip()
  print x, strftime("%d%b%Y %H:%M:%S", gmtime())
  command = ["seqret", "Alignments/" + x + ".fasta", "phylip::infile", "-auto"]
  seqret = Popen(command, stdout = PIPE, stderr = PIPE)
  (out, err) = seqret.communicate()
  if err:
    print err
    exit(1)
  command = ["fastme"]
  i = 0
  while not access("infile_fastme_tree.txt", F_OK):
    if i > 0:
      stderr.write(x + ": " + str(i) + '\n')
    fastme = Popen(command, stdin = PIPE, stdout = PIPE, stderr = PIPE)
#    (out, err) = fastme.communicate(input = "infile\ni\nd\ny\n") # Nucleic
    (out, err) = fastme.communicate(input = "infile\ni\np\ny\n") # Protein
    if err: stderr.write(err + '\n')
    i += 1
  logf = open("Logs/ME/" + x + ".log", "w")
  logf.write(out)
  logf.close()
  rename("infile_fastme_tree.txt", "Trees/ME/" + x  ".tre") 
  rename("infile_fastme_stat.txt", "Logs/ME/" + x + ".stat") 
  remove("infile")

names.close()